<template>
  <div class="toolbar-container">
    <Searchbar v-if="isSearching" @close="disableSearching" />
    <div class="toolbar" v-else>
      <ResponsiveComponent class="category-button" :break-point="340">
        <Button type="text" size="sm" color="white" @click.native="$store.dispatch('shop/toggleIsCategoryNavShown')">
          <template #icon>
            <MenuIcon v-if="!isCategoryNavShown"/>
            <CloseIcon v-else />
          </template>
          دسته بندی ها
        </Button>
        <template #collapsed>
          <Button type="text" round size="sm" color="white" @click.native="$store.dispatch('shop/toggleIsCategoryNavShown')">
            <template #icon>
              <MenuIcon v-if="!isCategoryNavShown"/>
              <CloseIcon v-else />
            </template>
          </Button>
        </template>
      </ResponsiveComponent>
      <Button
        round
        type="text"
        size="sm"
        color="white"
        @click.native="enableSearching"
      >
        <template #icon>
          <SearchIcon />
        </template>
      </Button>
      <div v-if="allowMultipleViewStyle" class="view-style-container">
        <Button
          v-if="isViewStyleGrid"
          round
          type="text"
          size="sm"
          color="white"
          @click.native="setViewStyleList"
          class="view-button"
        >
          <template #icon>
            <ListIcon />
          </template>
        </Button>
        <Button 
          v-else 
          round 
          type="text" 
          size="sm"
          color="white"
          @click.native="setViewStyleGrid"
          class="view-button"
        >
          <template #icon>
            <AppsIcon />
          </template>
        </Button>
      </div>
      <Button v-if="backRoute" class="back" type="text" round size="sm" color="white" @click.native="$router.push(backRoute)">
        <template #icon>
          <BackIcon />
        </template>
      </Button>
    </div>
  </div>
</template>

<script>
import { mapActions, mapGetters } from "vuex";
import Button from "@/components/base/Button";
import TextField from "@/components/base/TextField";
import ListIcon from "@/assets/svgs/view_list.svg";
import AppsIcon from "@/assets/svgs/apps.svg";
import MenuIcon from "@/assets/svgs/menu.svg";
import SearchIcon from "@/assets/svgs/search.svg";
import CloseIcon from "@/assets/svgs/close.svg";
import BackIcon from "@/assets/svgs/back.svg";
import Searchbar from "@/components/catalog/Searchbar";
import ResponsiveComponent from "@/components/base/ResponsiveComponent";

export default {
  name: "ShopToolbar",
  components: {
    Button,
    TextField,
    ListIcon,
    AppsIcon,
    MenuIcon,
    SearchIcon,
    CloseIcon,
    BackIcon,
    Searchbar,
    ResponsiveComponent
  },
  data() {
    return {
      screenWidth: 1000, // something bigger than 750. dosen't matter will update automaticaly.
      categories: [],
      isSearching: false
    };
  },
  methods: {
    ...mapActions({
      setViewStyleGrid: "shop/setViewStyleGrid",
      setViewStyleList: "shop/setViewStyleList"
    }),
    onResize() {
      this.screenWidth = window.innerWidth;
    },
    enableSearching() {
      this.isSearching = true;
    },
    disableSearching() {
      this.isSearching = false;
    }
  },
  computed: {
    ...mapGetters({
      getViewStyle: "shop/getViewStyle", 
      isCategoryNavShown: "shop/isCategoryNavShown",
      backRoute: "settings/getBackRoute"
    }),
    isViewStyleGrid() {
      return this.getViewStyle === "grid" ? true : false;
    },
    allowMultipleViewStyle() {
      return this.screenWidth > 750; 
    }
  },
  mounted() {
    window.addEventListener('resize', this.onResize);
    this.screenWidth = window.innerWidth;
  },
  beforeDestroy() {
    window.removeEventListener('resize', this.onResize);
  }
};
</script>

<style lang="stylus" scoped>
@import '~assets/styles/variables'
.toolbar
  color $white
  padding $shop-toolbar-padding
  height $shop-toolbar-height
  box-shadow $shop-toolbar-shadow
  display flex
  flex-direction row-reverse
  align-items center
  position relative
  z-index 6
  @media only screen and (max-width: 600px)
    padding $shop-toolbar-padding--sm

.category-button
  margin-left auto

.clear:hover
  cursor pointer
</style>

